import { hex2b64 as p } from "./lib/jsbn/base64.js";
import { Hex as E } from "./lib/asn1js/hex.js";
import { Base64 as R } from "./lib/asn1js/base64.js";
import { ASN1 as S } from "./lib/asn1js/asn1.js";
import { RSAKey as d } from "./lib/jsbn/rsa.js";
import { parseBigInt as a } from "./lib/jsbn/jsbn.js";
import { KJUR as n } from "./lib/jsrsasign/asn1-1.0.js";
var K = globalThis && globalThis.__extends || function() {
  var u = function(r, e) {
    return u = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(t, s) {
      t.__proto__ = s;
    } || function(t, s) {
      for (var o in s)
        Object.prototype.hasOwnProperty.call(s, o) && (t[o] = s[o]);
    }, u(r, e);
  };
  return function(r, e) {
    if (typeof e != "function" && e !== null)
      throw new TypeError("Class extends value " + String(e) + " is not a constructor or null");
    u(r, e);
    function t() {
      this.constructor = r;
    }
    r.prototype = e === null ? Object.create(e) : (t.prototype = e.prototype, new t());
  };
}(), V = function(u) {
  K(r, u);
  function r(e) {
    var t = u.call(this) || this;
    return e && (typeof e == "string" ? t.parseKey(e) : (r.hasPrivateKeyProperty(e) || r.hasPublicKeyProperty(e)) && t.parsePropertiesFrom(e)), t;
  }
  return r.prototype.parseKey = function(e) {
    try {
      var t = 0, s = 0, o = /^\s*(?:[0-9A-Fa-f][0-9A-Fa-f]\s*)+$/, h = o.test(e) ? E.decode(e) : R.unarmor(e), i = S.decode(h);
      if (i.sub.length === 3 && (i = i.sub[2].sub[0]), i.sub.length === 9) {
        t = i.sub[1].getHexStringValue(), this.n = a(t, 16), s = i.sub[2].getHexStringValue(), this.e = parseInt(s, 16);
        var f = i.sub[3].getHexStringValue();
        this.d = a(f, 16);
        var c = i.sub[4].getHexStringValue();
        this.p = a(c, 16);
        var y = i.sub[5].getHexStringValue();
        this.q = a(y, 16);
        var P = i.sub[6].getHexStringValue();
        this.dmp1 = a(P, 16);
        var l = i.sub[7].getHexStringValue();
        this.dmq1 = a(l, 16);
        var w = i.sub[8].getHexStringValue();
        this.coeff = a(w, 16);
      } else if (i.sub.length === 2)
        if (i.sub[0].sub) {
          var v = i.sub[1], g = v.sub[0];
          t = g.sub[0].getHexStringValue(), this.n = a(t, 16), s = g.sub[1].getHexStringValue(), this.e = parseInt(s, 16);
        } else
          t = i.sub[0].getHexStringValue(), this.n = a(t, 16), s = i.sub[1].getHexStringValue(), this.e = parseInt(s, 16);
      else
        return !1;
      return !0;
    } catch {
      return !1;
    }
  }, r.prototype.getPrivateBaseKey = function() {
    var e = {
      array: [
        new n.asn1.DERInteger({ int: 0 }),
        new n.asn1.DERInteger({ bigint: this.n }),
        new n.asn1.DERInteger({ int: this.e }),
        new n.asn1.DERInteger({ bigint: this.d }),
        new n.asn1.DERInteger({ bigint: this.p }),
        new n.asn1.DERInteger({ bigint: this.q }),
        new n.asn1.DERInteger({ bigint: this.dmp1 }),
        new n.asn1.DERInteger({ bigint: this.dmq1 }),
        new n.asn1.DERInteger({ bigint: this.coeff })
      ]
    }, t = new n.asn1.DERSequence(e);
    return t.getEncodedHex();
  }, r.prototype.getPrivateBaseKeyB64 = function() {
    return p(this.getPrivateBaseKey());
  }, r.prototype.getPublicBaseKey = function() {
    var e = new n.asn1.DERSequence({
      array: [
        new n.asn1.DERObjectIdentifier({ oid: "1.2.840.113549.1.1.1" }),
        new n.asn1.DERNull()
      ]
    }), t = new n.asn1.DERSequence({
      array: [
        new n.asn1.DERInteger({ bigint: this.n }),
        new n.asn1.DERInteger({ int: this.e })
      ]
    }), s = new n.asn1.DERBitString({
      hex: "00" + t.getEncodedHex()
    }), o = new n.asn1.DERSequence({
      array: [e, s]
    });
    return o.getEncodedHex();
  }, r.prototype.getPublicBaseKeyB64 = function() {
    return p(this.getPublicBaseKey());
  }, r.wordwrap = function(e, t) {
    if (t = t || 64, !e)
      return e;
    var s = "(.{1," + t + `})( +|$
?)|(.{1,` + t + "})";
    return e.match(RegExp(s, "g")).join(`
`);
  }, r.prototype.getPrivateKey = function() {
    var e = `-----BEGIN RSA PRIVATE KEY-----
`;
    return e += r.wordwrap(this.getPrivateBaseKeyB64()) + `
`, e += "-----END RSA PRIVATE KEY-----", e;
  }, r.prototype.getPublicKey = function() {
    var e = `-----BEGIN PUBLIC KEY-----
`;
    return e += r.wordwrap(this.getPublicBaseKeyB64()) + `
`, e += "-----END PUBLIC KEY-----", e;
  }, r.hasPublicKeyProperty = function(e) {
    return e = e || {}, e.hasOwnProperty("n") && e.hasOwnProperty("e");
  }, r.hasPrivateKeyProperty = function(e) {
    return e = e || {}, e.hasOwnProperty("n") && e.hasOwnProperty("e") && e.hasOwnProperty("d") && e.hasOwnProperty("p") && e.hasOwnProperty("q") && e.hasOwnProperty("dmp1") && e.hasOwnProperty("dmq1") && e.hasOwnProperty("coeff");
  }, r.prototype.parsePropertiesFrom = function(e) {
    this.n = e.n, this.e = e.e, e.hasOwnProperty("d") && (this.d = e.d, this.p = e.p, this.q = e.q, this.dmp1 = e.dmp1, this.dmq1 = e.dmq1, this.coeff = e.coeff);
  }, r;
}(d);
export {
  V as JSEncryptRSAKey
};
