import { parseBigInt as u, BigInteger as a, nbi as y } from "./jsbn.js";
import { SecureRandom as m } from "./rng.js";
function P(s, r) {
  if (r < s.length + 22)
    return console.error("Message too long for RSA"), null;
  for (var t = r - s.length - 6, e = "", n = 0; n < t; n += 2)
    e += "ff";
  var o = "0001" + e + "00" + s;
  return u(o, 16);
}
function w(s, r) {
  if (r < s.length + 11)
    return console.error("Message too long for RSA"), null;
  for (var t = [], e = s.length - 1; e >= 0 && r > 0; ) {
    var n = s.charCodeAt(e--);
    n < 128 ? t[--r] = n : n > 127 && n < 2048 ? (t[--r] = n & 63 | 128, t[--r] = n >> 6 | 192) : (t[--r] = n & 63 | 128, t[--r] = n >> 6 & 63 | 128, t[--r] = n >> 12 | 224);
  }
  t[--r] = 0;
  for (var o = new m(), l = []; r > 2; ) {
    for (l[0] = 0; l[0] == 0; )
      o.nextBytes(l);
    t[--r] = l[0];
  }
  return t[--r] = 2, t[--r] = 0, new a(t);
}
var E = function() {
  function s() {
    this.n = null, this.e = 0, this.d = null, this.p = null, this.q = null, this.dmp1 = null, this.dmq1 = null, this.coeff = null;
  }
  return s.prototype.doPublic = function(r) {
    return r.modPowInt(this.e, this.n);
  }, s.prototype.doPrivate = function(r) {
    if (this.p == null || this.q == null)
      return r.modPow(this.d, this.n);
    for (var t = r.mod(this.p).modPow(this.dmp1, this.p), e = r.mod(this.q).modPow(this.dmq1, this.q); t.compareTo(e) < 0; )
      t = t.add(this.p);
    return t.subtract(e).multiply(this.coeff).mod(this.p).multiply(this.q).add(e);
  }, s.prototype.setPublic = function(r, t) {
    r != null && t != null && r.length > 0 && t.length > 0 ? (this.n = u(r, 16), this.e = parseInt(t, 16)) : console.error("Invalid RSA public key");
  }, s.prototype.encrypt = function(r) {
    var t = this.n.bitLength() + 7 >> 3, e = w(r, t);
    if (e == null)
      return null;
    var n = this.doPublic(e);
    if (n == null)
      return null;
    for (var o = n.toString(16), l = o.length, i = 0; i < t * 2 - l; i++)
      o = "0" + o;
    return o;
  }, s.prototype.setPrivate = function(r, t, e) {
    r != null && t != null && r.length > 0 && t.length > 0 ? (this.n = u(r, 16), this.e = parseInt(t, 16), this.d = u(e, 16)) : console.error("Invalid RSA private key");
  }, s.prototype.setPrivateEx = function(r, t, e, n, o, l, i, h) {
    r != null && t != null && r.length > 0 && t.length > 0 ? (this.n = u(r, 16), this.e = parseInt(t, 16), this.d = u(e, 16), this.p = u(n, 16), this.q = u(o, 16), this.dmp1 = u(l, 16), this.dmq1 = u(i, 16), this.coeff = u(h, 16)) : console.error("Invalid RSA private key");
  }, s.prototype.generate = function(r, t) {
    var e = new m(), n = r >> 1;
    this.e = parseInt(t, 16);
    for (var o = new a(t, 16); ; ) {
      for (; this.p = new a(r - n, 1, e), !(this.p.subtract(a.ONE).gcd(o).compareTo(a.ONE) == 0 && this.p.isProbablePrime(10)); )
        ;
      for (; this.q = new a(n, 1, e), !(this.q.subtract(a.ONE).gcd(o).compareTo(a.ONE) == 0 && this.q.isProbablePrime(10)); )
        ;
      if (this.p.compareTo(this.q) <= 0) {
        var l = this.p;
        this.p = this.q, this.q = l;
      }
      var i = this.p.subtract(a.ONE), h = this.q.subtract(a.ONE), f = i.multiply(h);
      if (f.gcd(o).compareTo(a.ONE) == 0) {
        this.n = this.p.multiply(this.q), this.d = o.modInverse(f), this.dmp1 = this.d.mod(i), this.dmq1 = this.d.mod(h), this.coeff = this.q.modInverse(this.p);
        break;
      }
    }
  }, s.prototype.decrypt = function(r) {
    var t = u(r, 16), e = this.doPrivate(t);
    return e == null ? null : S(e, this.n.bitLength() + 7 >> 3);
  }, s.prototype.generateAsync = function(r, t, e) {
    var n = new m(), o = r >> 1;
    this.e = parseInt(t, 16);
    var l = new a(t, 16), i = this, h = function() {
      var f = function() {
        if (i.p.compareTo(i.q) <= 0) {
          var p = i.p;
          i.p = i.q, i.q = p;
        }
        var g = i.p.subtract(a.ONE), b = i.q.subtract(a.ONE), q = g.multiply(b);
        q.gcd(l).compareTo(a.ONE) == 0 ? (i.n = i.p.multiply(i.q), i.d = l.modInverse(q), i.dmp1 = i.d.mod(g), i.dmq1 = i.d.mod(b), i.coeff = i.q.modInverse(i.p), setTimeout(function() {
          e();
        }, 0)) : setTimeout(h, 0);
      }, v = function() {
        i.q = y(), i.q.fromNumberAsync(o, 1, n, function() {
          i.q.subtract(a.ONE).gcda(l, function(p) {
            p.compareTo(a.ONE) == 0 && i.q.isProbablePrime(10) ? setTimeout(f, 0) : setTimeout(v, 0);
          });
        });
      }, c = function() {
        i.p = y(), i.p.fromNumberAsync(r - o, 1, n, function() {
          i.p.subtract(a.ONE).gcda(l, function(p) {
            p.compareTo(a.ONE) == 0 && i.p.isProbablePrime(10) ? setTimeout(v, 0) : setTimeout(c, 0);
          });
        });
      };
      setTimeout(c, 0);
    };
    setTimeout(h, 0);
  }, s.prototype.sign = function(r, t, e) {
    var n = T(e), o = n + t(r).toString(), l = P(o, this.n.bitLength() / 4);
    if (l == null)
      return null;
    var i = this.doPrivate(l);
    if (i == null)
      return null;
    var h = i.toString(16);
    return h.length & 1 ? "0" + h : h;
  }, s.prototype.verify = function(r, t, e) {
    var n = u(t, 16), o = this.doPublic(n);
    if (o == null)
      return null;
    var l = o.toString(16).replace(/^1f+00/, ""), i = I(l);
    return i == e(r).toString();
  }, s;
}();
function S(s, r) {
  for (var t = s.toByteArray(), e = 0; e < t.length && t[e] == 0; )
    ++e;
  if (t.length - e != r - 1 || t[e] != 2)
    return null;
  for (++e; t[e] != 0; )
    if (++e >= t.length)
      return null;
  for (var n = ""; ++e < t.length; ) {
    var o = t[e] & 255;
    o < 128 ? n += String.fromCharCode(o) : o > 191 && o < 224 ? (n += String.fromCharCode((o & 31) << 6 | t[e + 1] & 63), ++e) : (n += String.fromCharCode((o & 15) << 12 | (t[e + 1] & 63) << 6 | t[e + 2] & 63), e += 2);
  }
  return n;
}
var d = {
  md2: "3020300c06082a864886f70d020205000410",
  md5: "3020300c06082a864886f70d020505000410",
  sha1: "3021300906052b0e03021a05000414",
  sha224: "302d300d06096086480165030402040500041c",
  sha256: "3031300d060960864801650304020105000420",
  sha384: "3041300d060960864801650304020205000430",
  sha512: "3051300d060960864801650304020305000440",
  ripemd160: "3021300906052b2403020105000414"
};
function T(s) {
  return d[s] || "";
}
function I(s) {
  for (var r in d)
    if (d.hasOwnProperty(r)) {
      var t = d[r], e = t.length;
      if (s.substr(0, e) == t)
        return s.substr(e);
    }
  return s;
}
export {
  E as RSAKey
};
